program MapCheck;


uses CevoMapFile, CevoMap;

var
    MapFile : tMapFile;
    Map     : tMap;


function GetMapFileName : string;
begin
	if ParamCount >= 1 then
		result := ParamStr(1)
	else
		result := '';
end;

procedure ShowStartPos (W,H : Integer);
var D : Boolean;
begin
    Writeln (MapFile.MapIndex(W,H)-1:5, ' ', Map.StartScore (W,H,D));

end;

procedure CheckMapBody;
var StartPositions, W, H,
    DeadLands,
    Cobalt,
    Uranium,
    Mercury : Integer;
    
begin
	StartPositions := 0;
	DeadLands      := 0;
	Cobalt         := 0;
	Uranium        := 0;
	Mercury        := 0;
	
	with MapFile do
		if fHeader.FormatID <> 'cEvoMap' then
			Writeln ('Not a Cevo Map File')
		else
		begin
			Writeln ('Start-Positions');
			Writeln ('Posn  Score');
			Writeln ('----- -- ');
			for W := 1 to Width do
				for H := 1 to height do
				begin
					If fBody[MapIndex(W,H)].StartPos in [$20, $40] then
					begin
						inc (StartPositions);
				        ShowStartPos (W,H);
				    end;
				
					case fBody[MapIndex(W,H)].Special and $7 of
						  0: {Nothing here};
						  1: inc (DeadLands);
						  3: inc (Cobalt);
						  5: inc (Uranium);
						  7: inc (Mercury);
					otherwise
						 writeln ('Invalid special ',fBody[MapIndex(W,H)].Special, ' at ', MapIndex(W,H));
					end;
				end;
			Writeln ('Total ',StartPositions);
			Writeln;
			Writeln ('Cobalt    ', Cobalt);
			Writeln ('Uranium   ', Uranium);
			Writeln ('Mercury   ', Mercury);
			Writeln ('DeadLands ', DeadLands);
		end;
end;


begin
	MapFile := tMapFile.Create;

    if MapFile.OpenMFile (GetMapFileName) then
		if MapFile.LoadFromFile then
			with MapFile.fHeader do
			begin
			   Writeln ('Size: ',LX, 'x', LY, LX*LY:6);
			   Writeln;
			   Map := tMap.Create (LX, LY, 0, 0, 0);
			   MapFile.LoadMapData (Map);
			   CheckMapBody;
			   Writeln;
			end
		else
			Writeln ('failed to load file ', GetMapFileName)
     else
         Writeln ('failed to open file ', GetMapFileName);

     MapFile.Free;
end.
